<?php
/**
 * @version $Id: install.script.php 44788 2011-11-05 06:06:27Z btowles $
 * @author RocketTheme, LLC http://www.rockettheme.com
 * @copyright Copyright (C) 2007 - 2012 RocketTheme, LLC
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

/**
 * Script file of HelloWorld component
 */
class com_RokQuickCartInstallerScript
{

    /**
     * method to run after an install/update/uninstall method
     *
     * @param $type
     * @param $parent
     * @return void
     */
    public function postflight($type, $parent)
    {
        if ($type == 'install') {
            $this->installSampleData($parent);
        }
    }

    /**
     * @param $parent JInstallerComponent
     */
    protected function installSampleData($parent)
    {

        $installer = $parent->getParent();
        $db =& JFactory::getDbo();

        // Initialise variables.
        $queries = array();

        $sqlfile = $installer->getPath('extension_root') . '/' . 'sql/sampledata.sql';

        // Check that sql files exists before reading. Otherwise raise error for rollback
        if (!file_exists($sqlfile)) {
            JError::raiseWarning(1, JText::sprintf('JLIB_INSTALLER_ERROR_SQL_FILENOTFOUND', $sqlfile));

            return false;
        }

        $buffer = file_get_contents($sqlfile);

        // Graceful exit and rollback if read not successful
        if ($buffer === false) {
            JError::raiseWarning(1, JText::_('JLIB_INSTALLER_ERROR_SQL_READBUFFER'));

            return false;
        }

        // Create an array of queries from the sql file
        jimport('joomla.installer.helper');
        $queries = JInstallerHelper::splitSql($buffer);

        if (count($queries) == 0) {
            // No queries to process
            return 0;
        }

        // Process each query in the $queries array (split out of sql file).
        foreach ($queries as $query)
        {
            $query = trim($query);

            if ($query != '' && $query{0} != '#') {
                $db->setQuery($query);

                if (!$db->query()) {
                    JError::raiseWarning(1, JText::sprintf('JLIB_INSTALLER_ERROR_SQL_ERROR', $db->stderr(true)));

                    return false;
                }
            }
        }


        return (int)count($queries);
    }
}