<?php
/**
* @version   $Id: error.php 1487 2012-07-02 15:25:24Z kevin $
* @author    RocketTheme http://www.rockettheme.com
* @copyright Copyright (C) 2007 - 2012 RocketTheme, LLC
* @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
*
* Gantry uses the Joomla Framework (http://www.joomla.org), a GNU/GPLv2 content management system
*
*/
defined( '_JEXEC' ) or die( 'Restricted access' );
if (!isset($this->error)) {
	$this->error = JError::raiseWarning( 403, JText::_('ALERTNOTAUTH') );
	$this->debug = false; 
}

// load and inititialize gantry class
require_once('lib/gantry/gantry.php');
$gantry->init();

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php echo $this->language; ?>" lang="<?php echo $this->language; ?>" dir="<?php echo $this->direction; ?>">
<head>

	<title><?php echo $this->error->getCode(); ?> - <?php echo $this->title; ?></title>
	<link rel="stylesheet" href="<?php echo $this->baseurl; ?>/templates/<?php echo $this->template; ?>/css/gantry-core.css" type="text/css" />
	<link rel="stylesheet" href="<?php echo $this->baseurl; ?>/templates/<?php echo $this->template; ?>/css/joomla-core.css" type="text/css" />
	<link rel="stylesheet" href="<?php echo $this->baseurl; ?>/templates/<?php echo $this->template; ?>/css/main-<?php $colorstyle = $gantry->get('main-body'); echo $colorstyle; ?>.css" type="text/css" />
	<link rel="stylesheet" href="<?php echo $this->baseurl; ?>/templates/<?php echo $this->template; ?>/css/fusionmenu.css" type="text/css" />
	<link rel="stylesheet" href="<?php echo $this->baseurl; ?>/templates/<?php echo $this->template; ?>/css/splitmenu.css" type="text/css" />
	<link rel="stylesheet" href="<?php echo $this->baseurl; ?>/templates/<?php echo $this->template; ?>/css/template.css" type="text/css" />
	<link rel="stylesheet" href="<?php echo $this->baseurl; ?>/templates/<?php echo $this->template; ?>/css/error.css" type="text/css" />

	<style type="text/css">
		<?php 
			$accentColor = new Color($gantry->get('main-accent'));
		    echo 'a, .menutop.fusion-js-container ul li > .item:hover, .splitmenu li .item:hover, .splitmenu li a:hover, .menutop.fusion-js-container li.f-menuparent-itemfocus > .item, .menutop li.root:hover > .item, .menutop li.root.f-mainparent-itemfocus > .item, #rt-subnavigation .splitmenu .item:hover, #rt-subnavigation .menu li.active .item, #rt-subnavigation .menutop li.active .item, .rt-totop:hover, .sprocket-tabs-nav li.active .sprocket-tabs-inner, .component-content .item h2 a:hover, .fusion-js-container .active > .item, .module-content ul.menu li.parent > li a:hover span, .module-content ul.menu li.parent > li .nolink:hover span, .module-content ul.menu li.parent li .item:hover span, .module-content ul.menu li.parent li a:hover span, .module-content ul.menu li.parent li .separator:hover, .module-content ul.menu li.parent .separator:hover, #rt-main .module-content ul.menu > li > a:hover, .component-content .items-leading h2 a:hover, .component-content .item-page h2 a:hover, #rt-menu a:hover, #k2Container .latestItemTitle a:hover {color:'.$gantry->get('main-accent').';}'."\n";
		    echo '.button:hover, .readon:hover, .readmore:hover, button.validate:hover, #member-profile a:hover, #member-registration a:hover, .formelm-buttons button:hover, .layout-showcase .sprocket-features-arrows .arrow:hover, .sprocket-mosaic-loadmore:hover, .title1 .module-title, .layout-showcase .readon, #k2Container .itemCommentsForm .button:hover, .sprocket-mosaic .sprocket-mosaic-filter li:hover, .sprocket-mosaic .sprocket-mosaic-order li:hover, .sprocket-mosaic .sprocket-mosaic-filter li.active, .sprocket-mosaic .sprocket-mosaic-order li.active, .fronttabs .image-description, .title4 .arrow-box, .menutop.level1 > li.active .item {background-color:'.$accentColor->lighten('5%').';}'."\n";
		    echo '.rt-totop:hover .totop-arrow, .module-content .menu li > a:hover > span > .menu-arrow, .module-content .menu li > .nolink:hover > span > .menu-arrow, .sprocket-lists-title, .sprocket-lists-arrows .arrow:hover, .sprocket-headlines-navigation .arrow:hover, .layout-slideshow .sprocket-features-arrows .arrow, .title2 .arrow-box, .module-content .menu li.current.active > a span .menu-arrow, .module-content .menu li.active#current > a span .menu-arrow {background-color: '.$gantry->get('main-accent').';}'."\n";
		    echo '.block-module .title3 .module-surround .module-title, #rt-main .title3 .module-surround .module-title, .title3 .module-surround .module-title, .component-content .item h2, #rt-footer .title, .component-content h1, .component-content .items-leading h2, .component-content .item-page h2, .component-content .item-page h2:after, .component-content .blog h2:after, .component-block .component-content h2, .component-content .weblink-category h2:after, .component-content .contact h2:after, .component-content .login h1:after, .component-content h2:after, .component-content h1:after, .title3.noblock .title:after, .component-content h2, .component-content .weblink-category h2, .title3.noblock .module-title:after {border-color: '.$gantry->get('main-accent').';}'."\n";
		?>
	</style>

</head>
<body <?php echo $gantry->displayBodyTag(); ?>>
	 <div class="rt-block">
        <a href="<?php echo $gantry->baseUrl; ?>" id="rt-logo"></a>
    </div>
	<div id="rt-error-body">
		<div class="rt-container">
			<div id="rt-body-surround" class="component-content">
				<div class="rt-error-box">
					<div>
					<h1 class="error-title title">Error: <span><?php echo $this->error->getCode(); ?></span> - <?php echo $this->error->getMessage(); ?></h1>
					<div class="error-content">
					<p><strong>You may not be able to visit this page because of:</strong></p>
					<ol>
						<li>an out-of-date bookmark/favourite</li>
						<li>a search engine that has an out-of-date listing for this site</li>
						<li>a mistyped address</li>
						<li>you have no access to this page</li>
						<li>The requested resource was not found.</li>
						<li>An error has occurred while processing your request.</li>
					</ol>
					<p></p>
					<p><a href="<?php echo $gantry->baseUrl; ?>" class="readon"><span>&larr; Home</span></a></p>
					</div>
				</div>
			</div>
		</div>
	</div>
	</div>
</body>
</html>
<?php
$gantry->finalize();
?>